1000 ; ***************************1010 ; *        80: XIOS         *1020 ; * ----------------------- *1030 ; *   BY SIMON TREW, 1989.  *1040 ; * ----------------------- *1050 ; *                         *1060 ; * These routines provide  *1070 ; * all the special XIOS,   *1080 ; * the OPEN, CLOSE and STA *1090 ; * -TUS, and the Graphics  *1100 ; * 8 checking. They handle *1110 ; * all calls to the S: rom *1120 ; * handler device.         *1130 ; *                         *1140 ; ***************************1150 ;1160 ; ӠӠΠӠ1170 ;1180 BASICS   = $26001190 TEMP1    = $F51200 BUFP     = BASICS+$00001210 GR8SET   = BASICS+$00751220 PUTCHR   = BASICS+$00DD1230 MOVEYX   = BASICS+$01381240 CLEARY   = BASICS+$016A1250 SCROLU   = BASICS+$018A1260 SCROLD   = BASICS+$01A61270 GETCHR   = BASICS+$01C51280 DELETE   = BASICS+$02071290 INSERT   = BASICS+$02241300 LOCATE   = BASICS+$02561310 INVERT   = BASICS+$02FF1320 ;1330  *= BASICS+$03181340 ;1350 MODE   .BYTE 0 Open screen mode1360 TEXTFLAG .BYTE 0 Text/Graphics1370 BUFLEN .BYTE 0 Input buffer length1380 ROWCRS = $54   Cursor row (y)1390 COLCRS = $55   Cursor column (x)1400 LMARGN = $52   Left margin1410 RMARGN = $53   Right margin1420 GRMODE = $57   Display mode1430 FOREG  = $2C5  Foreground colour1440 BACKG  = $2C6  Background colour1450 BORDER = $2C8  Border colour1460 IOCB   = $340  IOCB variables1470 ICCOM  = $3421480 ICAX1  = $34A1490 ICAX2  = $34B1500 ICAX3  = $34C1510 ICAX4  = $34D1520 ICAX5  = $34E1530 ;1540 ; ϠέŠӠ1550 ;1560 OPEN1570  LDA ICAX1,X   First save the OPEN1580  JSR SETINP    mode, then attempt1590  JSR OPEN8     to open the screen.1600  LDY #1        Success!1610 NOTOK1620  RTS1630 ;1640 ; ˠŠӠǠĠ1650 ;1660 CHECK81670  PHA1680  TYA1690  PHA1700  LDA GRMODE    Make sure we're1710  CMP #8        using mode 81720  BEQ OKMOD8    Otherwise attempt1730 OPEN81740  JSR GR8SET    to open.1750  CPY #1281760  BCC OPENOK    Can't open, do not1770  PLA           return to parent,1780  PLA           return to grand-1790  PLA           parent instead.1800  PLA           This avoids more1810  RTS           checking by parent.1820 OPENOK1830  LDA #79       If OK, set defaults1840  STA RMARGN    The user can change1850  LDA #0        these on config so1860  STA FOREG     they each have a1870  LDA #12       separate LDA even1880  STA BACKG     though they may be1890  LDA #12       the same.1900  STA BORDER1910  LDA #0        Set left margin1920  STA COLCRS+1  (as graphics may1930  STA BUFLEN    set it to 0) and1940  STA TEXTFLAG  place in TEXT mode,1950  LDA LMARGN    input mode 12.1960  STA COLCRS1970 OKMOD81980  PLA           Then restore regs1990  TAY           and return control2000  PLA           to parent.2010  RTS2020 ;2030 ; ԠӠƠǠ2040 ;2050 GETSTAT2060  LDY TEXTFLAG  Status of TEXTFLAG2070  STY $23       exactly as XIOd.2080  RTS           and store in IOCB.2090 ;2100 ; ̠Ӡ2110 ;2120 SPECIAL2130  JSR CHECK8    Check using mode 82140  TXA           Store X for later2150  PHA2160  JSR DOSPEC    Do special oper.2170  PLA           Get back X reg.2180  TAX           and use to reset2190  LDA MODE      Input Mode back to2200  STA ICAX1,X   its last value, in2210  STA $2A       ZIOCB also.2220  RTS2230 DOSPEC2240  LDA ICCOM,X   Standard OS drawto2250  CMP #$11      or Fill command?2260  BEQ DRAWLN2270  CMP #$122280  BNE NOTDRW    No, skip over2290 ;2300 ; ӠӠŠӺũ2310 ;2320 OLDLM .BYTE 02330 OLDRM .BYTE 02340 BPUT .BYTE 02350 DRAWV = $E4102360 DRAWLN2370  PHA2380  LDA TEXTFLAG  Check OK screen2390  BEQ BADMODE   (not textmode)2400  LDA 83        Save margins as2410  STA OLDRM     as the graphics2420  LDA 82        routines may2430  STA OLDLM     change them.2440  LDA ICCOM,X   If doing a SPECIAL2450  CMP #$11      then use the SPEC.2460  BCS NOTPLT    vector. If doing2470  AND #4        a GET then use the2480  BNE GETCMD    GET vector else2490  LDY #6        use the PUT vector.2500  BNE SKIPPL    This is so that the2510 GETCMD2520  LDY #4        PLOT and LOCATE2530  BNE SKIPPL    graphics command2540 NOTPLT2550  LDY #$A       handlers can use2560 SKIPPL2570  CLC           this routine for2580  LDA DRAWV,Y   their graphics,2590  ADC #1        as well as the2600  STA GODRAW+1  SPECIAL handler for2610  LDA DRAWV+1,Y the DRAW and FILL.2620  ADC #02630  STA GODRAW+22640  PLA2650 GODRAW2660  JSR $FFFF2670  CPY #128      If an error occ-2680  BCC NOTDER    urred then set the2690  STY TEMP1     TEXT mode, to allow2700  JSR SWAPTT    Basic etc. to print2710  LDY TEMP1     the error.2720 NOTDER2730  PHA2740  LDA OLDRM     Reset the margins2750  STA RMARGN    as they may have2760  LDA OLDLM     been changed by2770  STA LMARGN    the S: device.2780  PLA2790  RTS2800 BADMODE2810  LDY #145      Bad screen mode2820  PLA2830  RTS2840 ;2850 ; ŠԠҠΩ2860 ;2870 NOTDRW2880  CMP #$26      NOTE command?2890  BNE NOTNOTE2900  LDA ROWCRS    Put coords in the2910  STA ICAX5,X   params of NOTE.2920  LDA COLCRS    This avoids the2930  STA ICAX3,X   need for PEEKS to2940  LDA COLCRS+1  adresses which look2950  STA ICAX4,X   cryptic and defy2960  LDY #1        the point of CIO.2970  RTS2980 ;2990 ; ŠŠ3000 ;3010 NOTNOTE3020  CMP #$27      MOVE LINE command?3030  BNE NOTMOVE3040  LDA TEXTFLAG  Check text mode is3050  BNE BADMODE   not graphics3060  LDY ICAX1,X   Load lines to move3070  CPY #24       Out of range?3080  BCS ERR1413090  LDA ICAX2,X   have to use A and3100  TAX           transfer since cant3110  CPX #24       LDX indexed X !3120  BCS ERR1413130  JSR MOVEYX    Do Move Line3140  LDY #13150  BNE POPREGS3160 ERR1413170  LDY #141      Cursor out of range3180 POPREGS3190  RTS3200 ;3210 ; ҠŠ3220 ;3230 NOTMOVE3240  CMP #$28      Clear line ICAX13250  BNE NOTCLR3260  LDA TEXTFLAG  Check text mode is3270  BNE BADMODE   not graphics3280  LDY ICAX1,X   Cursor out of3290  CPY #24       range?3300  BCS ERR141B3310  JSR CLEARY    No, do CLEARY3320  LDY #13330  RTS3340 ERR141B3350  LDY #141      Cursor out of range3360  RTS3370 ;3380 ; ̠Р3390 ;3400 NOTCLR3410  CMP #$293420  BNE NOTSCRU3430  LDA TEXTFLAG  Check text mode is3440  BNE BADMODE   not graphics3450  LDY ICAX1,X   is the line out of3460  CPY #24       range?3470  BCS ERR141B3480  JSR SCROLU    No, do SCROLU3490 CLOSE3500  LDY #1        This operation will3510  RTS           do nice for CLOSE.3520 ;3530 ; ̠Π3540 ;3550 NOTSCRU3560  CMP #$2A      Scroll down ICAX1?3570  BNE CHGTEXT3580  LDA TEXTFLAG  Check text mode is3590  BNE BADMODE   not graphics3600  LDY ICAX1,X   Cursor out of3610  CPY #24       range?3620  BCS ERR141B3630  JSR SCROLD    No, do SCROLD3640  LDY #13650  RTS3660 ;3670 ; ŠŠΠǠ3680 ;3690 OLDROW .BYTE 03700 OLDCOL .WORD 03710 CHGTEXT3720  CMP #$2B        Change value3730  BNE NOTTEXT3740 SWAPTT3750  LDA TEXTFLAG    Toggle Textflag3760  EOR #13770  STA TEXTFLAG3780  LDX #23790 SWLOOP3800  LDA ROWCRS,X    Switch the two3810  LDY OLDROW,X    cursors, so that3820  STY ROWCRS,X    switching between3830  STA OLDROW,X    text and graphics3840  DEX             does not require3850  BPL SWLOOP      setting position.3860  LDY #13870  RTS3880 ;3890 ; ԠҠΠΠ3900 ;3910 NOTTEXT3920  CMP #$2C      Invert?3930  BNE NOTINV3940  LDA TEXTFLAG  Check text mode is3950  BEQ GOODMDE   not graphics3960  JMP BADMODE3970 GOODMDE3980  LDY ICAX2,X   Load char To invert3990  CPY #24       Out of range?4000  BCS ERR141D4010  LDA ICAX1,X   have to use A and4020  TAX           transfer since cant4030  CPX #80       load X indexed X!4040  BCS ERR141D4050  JSR INVERT    Do Invert Char4060  LDY #14070  RTS4080 ERR141D4090  JMP ERR1414100 ;4110 ; ŠԠŠ4120 ;4130 NOTINV4140  CMP #$2D     Input change?4150  BNE NOTIMPL  If so, set Y=1 now,4160  LDY #1 